// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
// #  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

vector<vector<map<int, string>>> dp(7);

void solve() {
	vector<int> p10 = {1};
	for (int i = 0; i < 6; ++i) {
		p10.push_back(p10.back() * 10);
	}

	vector<set<int>> need_nums(7);
	for (int l = 1; l <= 4; ++l) {
		for (int i = 0; i < p10[l]; ++i) {
			need_nums[l].insert(i);
			need_nums[l].insert(-i);
		}
	}

	for (int d = 0; d < 10; ++d) {
		// a + b = 100
		// a = 100 - b
		// b = 100 - a
		need_nums[5].insert(100 - d);
		need_nums[5].insert(100 + d);

		// a - b = 100
		// a = 100 + b
		// b = a - 100
		need_nums[5].insert(100 + d);
		need_nums[5].insert(d - 100);
		need_nums[5].insert(100 - d);
		need_nums[5].insert(-d - 100);

		// a * b = 100
		// a = 100 / b
		// b = 100 / a
		if (d && 100 % d == 0) {
			need_nums[5].insert(100 / d);
			need_nums[5].insert(-100 / d);
		}

		// a / b = 100
		// a = 100 * b
		// b = a / 100
		if (d) {
			need_nums[5].insert(100 * d);
			need_nums[5].insert(-100 * d);
		}
	}

	need_nums[6].insert(100);

	for (int l = 1; l <= 6; ++l) {
		dp[l].resize(p10[l]);
		cerr << l << endl;
		for (int i = 0; i < p10[l]; ++i) {
			auto& cur = dp[l][i];
			if ((l == 1 || i >= p10[l - 1]) && need_nums[l].count(i)) {
				// dp[l][i].push_back({i, to_string(i)});
				cur[i] = to_string(i);
			}
			if (l <= 4) {
				for (int left = 1; left < l; ++left) {
					int left_part = i / p10[l - left];
					int right_part = i % p10[l - left];
					auto& left_arr = dp[left][left_part];
					auto& right_arr = dp[l - left][right_part];
					for (auto& pl : left_arr) {
						for (auto& pr : right_arr) {
							if (!cur.count(pl.ff + pr.ff)) {
								cur[pl.ff + pr.ff] = "(" + pl.ss + "+" + pr.ss + ")";
							}
							if (!cur.count(pl.ff - pr.ff)) {
								cur[pl.ff - pr.ff] = "(" + pl.ss + "-" + pr.ss + ")";
							}
							if (!cur.count(pl.ff * pr.ff)) {
								cur[pl.ff * pr.ff] = "(" + pl.ss + "*" + pr.ss + ")";
							}
							if (pr.ff != 0 && pl.ff % pr.ff == 0 && !cur.count(pl.ff / pr.ff)) {
								cur[pl.ff / pr.ff] = "(" + pl.ss + "/" + pr.ss + ")";
							}
						}
					}
				}
			} else {
				for (int num : need_nums[l]) {
					bool found = false;
					for (int left = 1; left < l; ++left) {
						int left_part = i / p10[l - left];
						int right_part = i % p10[l - left];
						auto& left_arr = dp[left][left_part];
						auto& right_arr = dp[l - left][right_part];
						if (szof(left_arr) < szof(right_arr)) {
							for (auto& pl : left_arr) {
								// a + b = num
								// b = num - a
								int need = num - pl.ff;
								if (right_arr.count(need)) {
									dp[l][i][num] = "(" + pl.ss + "+" + right_arr[need] + ")";
									found = true;
									break;
								}

								// a - b = num
								// b = a - num
								need = pl.ff - num;
								if (right_arr.count(need)) {
									dp[l][i][num] = "(" + pl.ss + "-" + right_arr[need] + ")";
									found = true;
									break;
								}

								// a * b = num
								// b = num / a
								if (pl.ff != 0 && num % pl.ff == 0) {
									need = num / pl.ff;
									if (right_arr.count(need)) {
										dp[l][i][num] = "(" + pl.ss + "*" + right_arr[need] + ")";
										found = true;
										break;
									}
								}

								// a / b = num
								// b = a / num
								if (pl.ff != 0 && pl.ff % num == 0) {
									need = pl.ff / num;
									if (right_arr.count(need)) {
										dp[l][i][num] = "(" + pl.ss + "/" + right_arr[need] + ")";
										found = true;
										break;
									}
								}
							}
						} else {
							for (auto& pr : right_arr) {
								// a + b = num
								// a = num - b
								int need = num - pr.ff;
								if (left_arr.count(need)) {
									dp[l][i][num] = "(" + left_arr[need] + "+" + pr.ss + ")";
									found = true;
									break;
								}

								// a - b = num
								// a = num + b
								need = num + pr.ff;
								if (left_arr.count(need)) {
									dp[l][i][num] = "(" + left_arr[need] + "-" + pr.ss + ")";
									found = true;
									break;
								}

								// a * b = num
								// a = num / b
								if (pr.ff != 0 && num % pr.ff == 0) {
									need = num / pr.ff;
									if (left_arr.count(need)) {
										dp[l][i][num] = "(" + left_arr[need] + "*" + pr.ss + ")";
										found = true;
										break;
									}
								}

								// a / b = num
								// a = num * b
								if (pr.ff != 0) {
									need = pr.ff * num;
									if (left_arr.count(need)) {
										dp[l][i][num] = "(" + left_arr[need] + "/" + pr.ss + ")";
										found = true;
										break;
									}
								}
							}
						}

						if (found) {
							break;
						}
					}
				}
			}
			vector<pair<int, string>> to_add;
			for (auto p : dp[l][i]) {
				if (need_nums[l].count(-p.ff) && !dp[l][i].count(-p.ff)) {
					to_add.push_back({-p.ff, "-" + p.ss});
				}
			}
			for (auto p : to_add) {
				dp[l][i][p.ff] = p.ss;
			}
		}
	}

	string s;
	while (cin >> s) {
		int cur = stoi(s);
		if (dp[6][cur].count(100)) {
			cout << dp[6][cur][100] << "\n";
		} else {
			cout << "No solution\n";
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}