// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXN = 10'000;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();

    if (validator.group() == "1") {
        inf.readLine(format("[a-zA-Z]{%d}", n), "s");
    } else if (validator.group() == "2") {
        inf.readLine(format("[a-zA-Z0-9,.!?$()]{%d}", n), "s");
    } else {
        string s = inf.readLine();
        ensuref(szof(s) == n, "length %d", n);
        for (char c : s) {
            ensuref(('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z') || ('0' <= c && c <= '9') || c == ',' || c == '.' || c == '!' || c == '?' || c == '$' || c == '(' || c == ')' || c == ' ', "incorrect character '%c'", c);
        }
    }

    inf.readEof();

    return 0;
}